(*######################################################*)
(*			files.ml			*)
(*######################################################*)


exception Quit;;

let cur_input = ref std_in;;

let stack_input = ref ([]:in_channel list);;


let pop_input () = match !stack_input with
  c::s -> 
    close_in !cur_input;
    cur_input := c;
    stack_input := s
|  [] ->
    raise Quit
;;


let pop_all () =
  do_list (fun ch -> if ch <> std_in then close_in ch) !stack_input;
  stack_input:= [];
  cur_input:= std_in
;;

let path_list = ref [""];;
let ext = ".pred";;
let sep = `/`;;

let open_path filename = 
  let rec fn = function
    [] -> 
      raise (Failure (
       "File error: impossible to open file \""^filename^"\".\n"))
  | path::l ->
     try open_in (path^filename)
     with sys__Sys_error _ -> try open_in (path^filename^ext)
     with sys__Sys_error _ -> fn l
  in fn !path_list
;;

let read_file filename = 
  let old_input = !cur_input in
  cur_input := open_path filename;
  stack_input := old_input::!stack_input
;;

let add_path s = 
  let s = if nth_char s ((string_length s) - 1) <> sep 
          then s^(make_string 1 sep) else s in
  if not mem s !path_list then path_list := s::!path_list
;;

let print_path () = 
  do_list (fun x -> print_string x; print_newline()) !path_list
;;


