(*######################################################*)
(*			main.ml			*)
(*######################################################*)


#open "parser";;
#open "files";;
#open "sys";;

let prompt = ">pred>";;

let print_prompt() =
  print_string prompt; print_string " "; flush std_out
;;

let read_fun =
  let bol = ref true in
let rec fn = fun() ->
  if (!cur_input = std_in) & !bol then print_prompt();
  let c = try input_char (!cur_input) 
  with End_of_file -> pop_input (); fn () in
  if !cur_input = std_in then bol := c == `\n`;
  c
in fn
;;

let rec reset_lexer = function
    [< '`\n` ; str >] -> () 
|   [< '_ ; str >] -> reset_lexer str
|   [< >] -> ()
;;

let rec go () = 
catch_break true;  
try while true do 
  let cstrm = stream_from read_fun in
  let tstrm = lexer cstrm in
  (try 
    parse_cmd tstrm
  with 
    Failure s -> print_string "Failure: ";print_string s;
                 print_string "\n"; reset_lexer cstrm; pop_all ()
  | sys__Break -> print_string "Interupt.\n"; pop_all ()
  | Out_of_memory -> print_string "Fail: Out of Memory\n"; pop_all ()
  | Parse_error | Parse_failure -> 
      print_string "Syntax error\n";
      reset_lexer cstrm; pop_all ()
  ); flush stdout
done
with 
  Quit -> print_string "\nbye\n"; flush stdout
;;


go ();;
