(* gnrateur alatoire de formules *)

(* transforme une liste en un arbre binaire en utilisant la fonction conn
   pour construire les noeuds de l'arbre *)

let rec make_bin conn = function
    [a] -> a
  | a::l -> conn a (make_bin conn l)
  | _ -> failwith "bug in make_bin"
;;

(* fabrique nc clauses de longueur lc utilisant nv variables *)

let random_clause nv nc lc = 
  let rec fn l = function
	0 -> l
  | n -> let v = random__int nv and b = (random__int 2 = 1) in
         if exists (fun (_,v') -> v = v') l then fn l n else fn ((b,v)::l) (n-1)
  and gn l = function
    0 -> l
  | n -> gn ((fn [] lc)::l) (n-1)
  in gn [] nc
;;

(* transforme une liste de clauses en une disjonction de conjonctions *)

let clause_to_form neg cl =
  make_bin (fun x y -> Bin((if neg then Ou else Et),x,y))
    (map (fun l -> 
      make_bin (fun x y -> Bin((if neg then Et else Ou),x,y)) 
        (map (function b,n -> if neg <> b then Var n else Non (Var n)) l)) cl)
;;

(* gnrateur alatoire de formules *)

let random_form tt n p = clause_to_form true (random_clause tt n p);;

